#encoding:utf-8

'''
定义外设数据项
'''
from lib.protocol.message.MessageBase import MessageBase


class AlarmEvent_data(MessageBase):
    def __init__(self):
        super().__init__()
        pass

    #####################################################
    # 创建轿车OBD数据
    #####################################################
    def generateAlarmEvent_data(self):
        data = ""
        #怠速过长报警	附带信息见 表 C6EXT1
        idlingSpeedOver = "0106" + self.int2hexStringByBytes(9) + self.getIdlingSpeedOver()
        #超速报警	附带信息见 表 C6EXT2
        overspeedAlarm = "0107" + self.int2hexStringByBytes(9) + self.getOverspeedAlarm()
        #疲劳驾驶报警	附带信息见 表 C6EXT3
        fatigueDriving = "0108" + self.int2hexStringByBytes(5) + self.getFatigueDriving()
        #水温报警	附带信息见 表 C6EXT4
        waterTemperatureAlarm = "0109" + self.int2hexStringByBytes(9) + self.getWaterTemperatureAlarm()
        data = data + idlingSpeedOver + overspeedAlarm + fatigueDriving + waterTemperatureAlarm
        return data

    #####################################################
    # 获取怠速过长附带信息
    #####################################################
    def getIdlingSpeedOver(self):
        #报警属性  1：报警触发（无下面的数据内容项）0：报警解除（有下面的数据内容项）
        alarmType = self.int2hexStringByBytes(1)
        #怠速持续时间  怠速持续的时间（含报警前的预判时间），单位为秒
        idlingTimeOfDuration = self.int2hexStringByBytes(600,2)
        #怠速耗油量	单位 mL
        idlingOilExpend = self.int2hexStringByBytes(1200,2)
        #怠速最高转速	单位 RPM
        idlingEngineMaxSpeed = self.int2hexStringByBytes(5000,2)
        #怠速最低转速	单位 RPM
        idlingEngineMinSpeed = self.int2hexStringByBytes(500,2)
        data = alarmType + idlingTimeOfDuration + idlingOilExpend + idlingEngineMaxSpeed + idlingEngineMinSpeed
        return data

    #####################################################
    # 获取超速报警信息
    #####################################################
    def getOverspeedAlarm(self):
        #报警属性	1	BYTE	1：报警触发（无下面的数据内容项） 0：报警解除（有下面的数据内容项）
        alarmType = self.int2hexStringByBytes(0)
        #超速持续时间	2	WORD	怠速持续的时间（含报警前的预判时间），单位为秒
        overspeedTimeOfDuration = self.int2hexStringByBytes(700,2)
        #最高车速	2	WORD	单位 0.1KM/H
        maxSpeed = self.int2hexStringByBytes(145,2)
        #平均车速	2	WORD	单位 0.1KM/H
        averageSpeed = self.int2hexStringByBytes(70,2)
        #超速行驶距离	2	WORD	单位米
        overspeedDistance = self.int2hexStringByBytes(10000,2)
        data = alarmType + overspeedTimeOfDuration + maxSpeed + averageSpeed + overspeedDistance
        return data

    #####################################################
    # 获取疲劳驾驶报警附带信息
    #####################################################
    def getFatigueDriving(self):
        #报警属性	1	BYTE	1：报警触发（无下面的数据内容项） 0：报警解除（有下面的数据内容项）
        alarmType = self.int2hexStringByBytes(0)
        #累计持续驾驶时间	4	DWORD	车辆点火行驶到报警解除的累计行驶时间，单位为秒
        totalContinueDrivingTime = self.int2hexStringByBytes(21000,4)
        data = alarmType + totalContinueDrivingTime
        return data

    #####################################################
    # 获取疲劳驾驶报警附带信息
    #####################################################
    def getWaterTemperatureAlarm(self):
        #报警属性	1	BYTE	1：报警触发（无下面的数据内容项） 0：报警解除（有下面的数据内容项）
        alarmType = self.int2hexStringByBytes(1)
        #持续时长	4	DWORD	单位秒
        timeOfDuration = self.int2hexStringByBytes(11000,4)
        #最高温度	2	WORD	单位 0.1 度
        maxTemperature = self.int2hexStringByBytes(700,2)
        #平均温度	2	WORD	单位 0.1 度
        averageTemperature = self.int2hexStringByBytes(55,2)
        data = alarmType + timeOfDuration + maxTemperature + averageTemperature
        return data

if __name__ == "__main__":
    print(AlarmEvent_data().generateAlarmEvent_data())





