from flask import Flask, redirect

from views.protocolTools.setting_view import setting_view
from views.protocolTools.setting_process import setting_process
from views.protocolTools.protocolReport_view import protocolReport_view
from views.protocolTools.protocolReport_process import protocolReport_process
from views.protocolTools.test_view import test_view

from views.messageTools.msgSetting_view import msgSetting_view
from views.messageTools.msgSetting_process import msgSetting_process
from views.messageTools.message_view import message_view
from views.messageTools.message_process import message_process


from views.tab1.style import style
from views.tab1.icon import icon
from views.tab2.login import login
from views.tab2.example import example
from views.other import other

app = Flask(__name__)
app.register_blueprint(setting_view,url_prefix = "/protocolTools/setting_view")
app.register_blueprint(setting_process,url_prefix = "/protocolTools/setting_process")
app.register_blueprint(protocolReport_view,url_prefix = "/protocolTools/protocolReport_view")
app.register_blueprint(protocolReport_process,url_prefix = "/protocolTools/protocolReport_process")
app.register_blueprint(test_view,url_prefix = "/protocolTools/test_view")

app.register_blueprint(msgSetting_view,url_prefix = "/messageTools/msgSetting_view")
app.register_blueprint(msgSetting_process,url_prefix = "/messageTools/msgSetting_process")
app.register_blueprint(message_view,url_prefix = "/messageTools/message_view")
app.register_blueprint(message_process,url_prefix = "/messageTools/message_process")

app.register_blueprint(style,url_prefix = "/tab1/style")
app.register_blueprint(icon,url_prefix = "/tab1/icon")
app.register_blueprint(login,url_prefix = "/tab2/login")
app.register_blueprint(example,url_prefix = "/tab2/example")
app.register_blueprint(other,url_prefix = "/other")

@app.route('/')
def hello():
    return redirect('/tab1/style')

if __name__ == '__main__':
    app.run(debug=True,host='0.0.0.0')