#coding:utf-8

from flask import Blueprint ,Response,request
from configparser import ConfigParser

from lib.protocol.message.TerminalHeartbeat_msg import TerminalHeartbeat_msg
from lib.protocol.messageRes.PlatformCommon_res import PlatformCommon_res
from lib.protocol.report.HeartBeatReport_protocol import HeartBeatReport_protocol

from lib.socket.ClientSocket import ClientSocket
import json
import traceback
import binascii

message_process = Blueprint('message_process', __name__)

##########################################
#   【接口类型】处理发送的心跳消息
##########################################
@message_process.route("/porcessHeartBeatMsg",methods=['POST'])
def porcessHeartBeatMsg():
    msgID = request.form.get("msgID")
    phoneNum = request.form.get("phoneNum")
    msgWaterCode = request.form.get("msgWaterCode")
    encryptionType = request.form.get("encryptionType")
    subPkg = request.form.get("subPkg")
    pkgCounts = request.form.get("pkgCounts")


    data = {}
    if (msgID == None or phoneNum == None or msgWaterCode == None or encryptionType == None or subPkg == None or pkgCounts == None):
        data["status"] = "4003"
        data["message"] = "Info: 请检查是否传入了空数据！"
        return Response(json.dumps(data), mimetype='application/json')
    else:
        try:
            conf_R = ConfigParser()
            conf_R.read("config/messageTools/messageTools.conf")
            cliSocket = ClientSocket(conf_R.get("socket", "host"),conf_R.getint("socket", "port"))
            cliSocket.connect()
            heartBeatmsgObj = TerminalHeartbeat_msg()
            msg = heartBeatmsgObj.generateMsg()
            cliSocket.send(msg)
            socRecv_1 = cliSocket.receive()
            socRecv_2 = str(socRecv_1)
            cliSocket.close()
            data["status"] = "200"
            data["message"] = "Sucess: "
            data["result"] = socRecv_2
            data["parse"] = PlatformCommon_res(socRecv_1).getMsg()
        except BaseException as e:
            # 打印异常信息
            traceback.print_exc()
            data["status"] = "4003"
            data["message"] = "Error: 处理失败！"
    return Response(json.dumps(data), mimetype='application/json')